%global dlrn_nvr openstacksdk-0.55.1-17.1.20230622011025.f09ed4a
%global dlrn 1
%define upstream_version 0.55.1

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

# Disable docs until bs4 package is available
%global with_doc 0

%global pypi_name openstacksdk

%global common_desc \
A collection of libraries for building applications to work with OpenStack \
clouds.

%global common_desc_tests \
A collection of libraries for building applications to work with OpenStack \
clouds - test files

Name:           python-%{pypi_name}
Version: 0.55.1
Release: 17.1.20230622011026.f09ed4a%{?dist}
Summary:        An SDK for building applications to work with OpenStack

License:        ASL 2.0
URL:            http://www.openstack.org/
Source0: openstacksdk-0.55.1-17.1.20230622011025.f09ed4a.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=f09ed4ac566300fa6ab240cf39b38d853684cc57

BuildArch:      noarch

BuildRequires:  git-core

%description
%{common_desc}

%package -n python3-%{pypi_name}
Summary:        An SDK for building applications to work with OpenStack
%{?python_provide:%python_provide python3-%{pypi_name}}

BuildRequires:  python3-devel
BuildRequires:  python3-pbr >= 2.0.0
BuildRequires:  python3-keystoneauth1
BuildRequires:  python3-appdirs
BuildRequires:  python3-requestsexceptions
BuildRequires:  python3-munch
BuildRequires:  python3-jmespath
BuildRequires:  python3-jsonschema
BuildRequires:  python3-os-service-types
# Test requirements
BuildRequires:  python3-importlib-metadata
BuildRequires:  python3-iso8601 >= 0.1.11
BuildRequires:  python3-jsonpatch >= 1.16
BuildRequires:  python3-subunit
BuildRequires:  python3-oslotest
BuildRequires:  python3-oslo-config
BuildRequires:  python3-stestr
BuildRequires:  python3-mock
BuildRequires:  python3-testrepository
BuildRequires:  python3-testscenarios
BuildRequires:  python3-testtools
BuildRequires:  python3-requests-mock
BuildRequires:  python3-dogpile-cache
BuildRequires:  python3-ddt
BuildRequires:  python3-decorator
BuildRequires:  python3-netifaces

Requires:       python3-cryptography >= 2.7
Requires:       python3-importlib-metadata >= 1.7.0
Requires:       python3-jsonpatch >= 1.16
Requires:       python3-keystoneauth1 >= 3.18.0
Requires:       python3-pbr >= 2.0.0
Requires:       python3-appdirs
Requires:       python3-requestsexceptions >= 1.2.0
Requires:       python3-munch
Requires:       python3-jmespath
Requires:       python3-iso8601
Requires:       python3-os-service-types >= 1.7.0
Requires:       python3-dogpile-cache
Requires:       python3-decorator
Requires:       python3-netifaces
Requires:       python3-yaml >= 3.13

%description -n python3-%{pypi_name}
%{common_desc}

%package -n python3-%{pypi_name}-tests
Summary:        An SDK for building applications to work with OpenStack - test files

Requires: python3-%{pypi_name} = %{version}-%{release}

%description -n python3-%{pypi_name}-tests
%{common_desc_tests}

%if 0%{?with_doc}
%package -n python-%{pypi_name}-doc
Summary:        An SDK for building applications to work with OpenStack - documentation
BuildRequires:  python3-openstackdocstheme
BuildRequires:  python3-sphinx

%description -n python-%{pypi_name}-doc
A collection of libraries for building applications to work with OpenStack
clouds - documentation.
%endif

%prep
%autosetup -n %{pypi_name}-%{upstream_version} -S git
# Let RPM handle the requirements
rm -rf {,test-}requirements.txt
# This unit test requires python-prometheus, which is optional and not needed
rm -f openstack/tests/unit/test_stats.py

%build
%{py3_build}

%if 0%{?with_doc}
# generate html docs
sphinx-build-3 -b html doc/source html
# remove the sphinx-build-3 leftovers
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%{py3_install}

%check
rm -f ./openstack/tests/unit/test_hacking.py
export OS_STDOUT_CAPTURE=true
export OS_STDERR_CAPTURE=true
export OS_TEST_TIMEOUT=20
# FIXME(jpena) we are skipping some unit tests due to
# https://storyboard.openstack.org/#!/story/2005677
PYTHON=python3 stestr-3 --test-path ./openstack/tests/unit run --black-regex '(test_wait_for_task_.*|.*TestOsServiceTypesVersion.*|.*test_timeout_and_failures_not_fail.*)'

%files -n python3-%{pypi_name}
%doc README.rst
%license LICENSE
%{_bindir}/openstack-inventory
%{python3_sitelib}/openstack
%{python3_sitelib}/%{pypi_name}-*.egg-info
%exclude %{python3_sitelib}/openstack/tests

%files -n python3-%{pypi_name}-tests
%{python3_sitelib}/openstack/tests

%if 0%{?with_doc}
%files -n python-%{pypi_name}-doc
%doc html
%license LICENSE
%endif

%changelog
* Wed Jun 21 2023 OSP Prod Chain <dev-null@redhat.com> 0.55.1-17.1.20230622011025.f09ed4a
- Update patches

* Wed Jul 27 2022 OSP Prod Chain <dev-null@redhat.com> 0.55.1-1.20220727181957.f09ed4a
- Update patches

* Thu Jul 14 2022 OSP Prod Chain <dev-null@redhat.com> 0.55.1-1.20220714123825.f09ed4a
- Update patches

* Wed Jul 13 2022 OSP Prod Chain <dev-null@redhat.com> 0.55.1-1.20220713081140.f09ed4a
- Update patches

* Fri Apr 08 2022 OSP Prod Chain <dev-null@redhat.com> 0.55.1-0.20220408073044.f09ed4a
- Update patches
- Increase RAM for the Ironic CI jobs
- Don't send empty remote_address_group_id for security groups
- Update TOX_CONSTRAINTS_FILE for stable/wallaby
- Update .gitreview for stable/wallaby

* Fri Apr 08 2022 OSP Prod Chain <dev-null@redhat.com> 0.55.0-0.20220408062725.964fec6
- Increase RAM for the Ironic CI jobs
- Don't send empty remote_address_group_id for security groups
- Update TOX_CONSTRAINTS_FILE for stable/wallaby
- Update .gitreview for stable/wallaby

* Thu May 27 2021 OSP Prod Chain <dev-null@redhat.com> 0.55.0-0.20210527232302.964fec6
- Update patches

* Wed Mar 24 2021 OSP Prod Chain <dev-null@redhat.com> 0.55.0-1
- Update patches

* Fri Mar 19 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Mar 17 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Mar 17 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- add masakari enabled to segment
- Switch cloud.networking.qos* operations to rely on proxy layer
- Set resource URI properties in listing method
- Prevent the endless loop in resource listing

* Wed Mar 10 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Improve Ironic API on OpenStack SDK
- Fix a trivial error in one of the error messages
- Add shared file systems support
- Add compute microversion 2.70
- Add TODO to remove md5 wrapper
- Remove unnecessary string formatting
- Drop .json suffix from networking URLs
- Support Deploy Templates for Ironic API
- Change microseconds to total_seconds()
- Move 'collections.Mapping' to 'collections.abc'
- Add ALPN support to load balancer pools
- Update Open Telekom Cloud vendor docu
- Complete compute.hypervisor functions
- encapsulate md5 calls for fips
- Support SNAP_REAL_HOME when using openstacksdk inside a snap package
- Add id query parameter to sg rules

* Tue Jan 26 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Apply urllib.parse.quote in unittests to get_mock_url
- Add query parameters to listing heat stacks
- Complete compute.service operations
- New volume availability zone resource, new functional and unit tests
- Trival change: Correct some errors
- Modify cloud.get_aggregate to use proxy.find
- Support roles 'name' in list_roles call
- Refresh deprecated link
- Add ``device_profile`` attribute to ``port``
- Change nodepool job to build CentOS-8-stream (unblock gate)
- Fix invalid argument formatting in log messages
- Add support for updating Block Storage Volume type extra_spec attributes
- Drop swift check for volume backup
- Add new Open Telekom Cloud region into the profile
- Support remote address group in SG rules
- Add support for overriding list base_path in find function
- Add support for Block Storage (v3) VolumeType Encyption resources
- Fix exception parsing when using WSME
- Add tls_enabled param for Octavia Pools
- Volume Target support for Ironic on OpenStack SDK
- Switch flavor ops in the cloud layer to proxy
- Update TOX_CONSTRAINTS_FILE

* Tue Dec 15 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Sun Nov 22 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add update_flavor method
- Remove duplicate test_zone_create
- Complete compute aggregate functions
- Fix the invalid if statement
- Add user_id as optional param to keypair operations
- Fix invalid assertIsNotNone statement

* Fri Nov 13 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Tue Sep 29 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Fix l-c testing for ubuntu focal
- Fix a bogus error in config loader when using several args with dashes
- Update TOX_CONSTRAINTS_FILE for stable/victoria
- Update .gitreview for stable/victoria

* Sun Sep 13 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Thu Sep 10 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Thu Sep 10 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Update config to Keystone v3
- Add support for filters into the project cleanup
- Stop falling back to image import
- Add "numa_affinity_policy" attribute to "port"
- baremetal-introspection: allow fetching unprocessed data
- Add compute microversion 2.6 and 2.8
- Use unittest.mock instead of mock
- Functional tests to explicitly use ML2/OVS
- Add block_storage find functions
- Allow passing in a logging handler
- Tolerate images created with other means
- switch to importlib.metadata for entrypoint loading
- Ignore IPv6 addresses if force_ipv4 is set
- Add TLS protocol support for Octavia

* Wed Jul 08 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Remove enforcer
- Add support for multiple image stores
- Upload image via interop import if needed
- Don't use random.SystemRandom in tests
- Drop python3.5 support
- Remove neutron-fwaas from the jobs' required project
- baremetal: support for volume connectors API
- Add query parameter 'id' for security_groups
- Wait for the project cleanup to complete
- Fix deleting stacks by id when waiting for result

* Tue Jun 30 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- NIT: Fix application credential
- Add user_projects method to docs index
- Do not clean keypairs in the project cleanup
- Make optional name and admin password
- Add some unit tests for config.loader
- Fix AttributeError exception during authorization
- baremetal: use proxy methods in unregister_machine
- Refresh python versions
- Switch to newer openstackdocstheme and reno versions
- Extend statistics reporting
- add default user and project domain for OVH provider
- new ovh-us provider for OVH US regions
- added new regions for provider OVH
- Fix issues found by latest flake8
- Set BaseImageProxy.create_image validate_checksum default to False
- Stop subclassing object
- Remove use of six
- Remove uses of from six.moves
- Remove some unneeded things from test-requirements
- Fix image owner field
- Strip self from incoming glance properties
- Add name query filter to keystone service
- Don't error if clouds.yaml is not readable
- Fix metric names in the object_store
- Add "id" to Port's query parameters
-  Add cipher list support for octavia
- Update docs to work with newer Sphinx
- Fix an unstable bare metal unit test
- OpenStack port decorator variables
- Update master for stable/ussuri
- Add ansible stable-2.9 job and run 2.8 and 2.9

* Wed Apr 15 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Apr 08 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Tue Apr 07 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Volume.backup API attr name fixes
- Update to hacking 3.0
- Update local hacking checks
- Raise hacking to 2.x
- Re-add nodepool functional test
- Add availability zone and availability zone profile resources to load balancer
- Small cleanups after Python2 drop
- Turn off test log capture for now
- Add python-requires entry indicating 3.5 is required
- Remove kwargs validation for identity project updates
- Change default image type in the OTC vendor profile
- Add unit test for rackspace block-storage workaround
- Fix the wrong doc use oslo_conf param
- Added missing {user, project}_domain_name in Api

* Tue Apr 07 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Mon Mar 30 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Revert "Switch to futurist for concurrency"
- [tests] Improve devstack/post playbook efficiency
- Add Release notes entry for Identity v3 IDP, Mapping and Protocol
- Add support for Federation Protocols
- Update Rackspace vendor profile for cinder v2
- Add support for Identity Providers
- Lay a foundation for the project cleanup
- Add support for not including the ID in creation requests
- Run fetch-subunit-output role conditionally
- Add bulk creation of rules for Security Group.
- Add support for federation mappings
- Add Octavia quota to the SDK docs
- Import generate_temp_url from swiftclient
- Set max_microversion to 2.53 for hypervisors
- baremetal: fail-less mode for wait_for_nodes_provision_state
- Rationalize examples and functional extra config loading
- Fix microversion negotiation in some bare metal node call
- Set min version to test node retirement
- Add support for additional volume backup options
- Switch to futurist for concurrency
- Add description field to portforwarding NAT rules
- Fixes get_user when identity responses are paged

* Fri Mar 20 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Support for stateless security groups
- Consistent normalization of Machine objects in the cloud layer
- Fix aggregate functional test for id restriction
- Extract check temp_url_key logic
- Add retired and retired_reason fields to baremetal node
- Normalise create_coe_cluster{,_template} results
- Fix service_type test for magnum in gate
- Handle old status-less placement service
- Return uuid alias for coe_cluster in non strict mode
- Replace assertItemsEqual with assertCountEqual
- Add port property: ip_allocation
- Include "fields" to "SecurityGroup" query parameters
- Include user_id attribute in volume information
- Add availability_zone param to load balancer
- Implement If-Match support for Neutron resources
- Fix: Set image name correctly if filename is not passed
- Add bulk port create.
- Add method for bulk creating objects.
- Change of auth url and regions
- Adding basic implementation for Accelerator(Cyborg)

* Thu Mar 19 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Support for stateless security groups
- Consistent normalization of Machine objects in the cloud layer
- Fix aggregate functional test for id restriction
- Extract check temp_url_key logic
- Add retired and retired_reason fields to baremetal node
- Normalise create_coe_cluster{,_template} results
- Fix service_type test for magnum in gate
- Handle old status-less placement service
- Return uuid alias for coe_cluster in non strict mode
- Replace assertItemsEqual with assertCountEqual
- Add port property: ip_allocation
- Include "fields" to "SecurityGroup" query parameters
- Include user_id attribute in volume information
- Add availability_zone param to load balancer
- Implement If-Match support for Neutron resources
- Fix: Set image name correctly if filename is not passed
- Add bulk port create.
- Add method for bulk creating objects.
- Change of auth url and regions
- Adding basic implementation for Accelerator(Cyborg)
- Support for stateless security groups
- Consistent normalization of Machine objects in the cloud layer
- Fix aggregate functional test for id restriction
- Extract check temp_url_key logic
- Add retired and retired_reason fields to baremetal node
- Normalise create_coe_cluster{,_template} results
- Fix service_type test for magnum in gate
- Handle old status-less placement service
- Return uuid alias for coe_cluster in non strict mode
- Replace assertItemsEqual with assertCountEqual
- Add port property: ip_allocation
- Include "fields" to "SecurityGroup" query parameters
- Include user_id attribute in volume information
- Add availability_zone param to load balancer
- Implement If-Match support for Neutron resources
- Fix: Set image name correctly if filename is not passed
- Add bulk port create.
- Add method for bulk creating objects.
- Change of auth url and regions
- Adding basic implementation for Accelerator(Cyborg)

* Thu Mar 12 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Support for stateless security groups
- Consistent normalization of Machine objects in the cloud layer
- Fix aggregate functional test for id restriction
- Extract check temp_url_key logic
- Add retired and retired_reason fields to baremetal node
- Normalise create_coe_cluster{,_template} results
- Fix service_type test for magnum in gate
- Handle old status-less placement service
- Return uuid alias for coe_cluster in non strict mode
- Replace assertItemsEqual with assertCountEqual
- Add port property: ip_allocation
- Include "fields" to "SecurityGroup" query parameters
- Include user_id attribute in volume information
- Add availability_zone param to load balancer
- Implement If-Match support for Neutron resources
- Fix: Set image name correctly if filename is not passed
- Add bulk port create.
- Add method for bulk creating objects.
- Change of auth url and regions
- Adding basic implementation for Accelerator(Cyborg)

* Thu Mar 05 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Fix error handling in network trunks operations
- Fix error handling on add/remove router iface calls
- Fail a job for ansible modules with message
- Add allowed_cidrs param to load balancer listener

* Wed Feb 19 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Mon Feb 03 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Use the bifrost bionic CI job
- Merge ""qos_network_policy_id" attribute added to port resource"
- Merge "Replace six.iteritems() with .items()"
- "qos_network_policy_id" attribute added to port resource
- Replace six.iteritems() with .items()
- Bump min version of decorator
- Merge "Fix bug in object storage container creation setting metadata"
- Fix bug in object storage container creation setting metadata
- Merge "Fix duplicated words issue like "was not not found""
- Add reset_interfaces argument to patch_node
- Fix duplicated words issue like "was not not found"
- Merge "Add return cluster_id when query actions list"
- Handle HTTP errors in add/remove router interface calls
- Merge "Add dns_publish_fixed_ip attribute to subnets"
- Add return cluster_id when query actions list
- Merge "Switch stable ansible job to 2.8"
- Merge "Remove extra python2 test jobs"
- Merge "Stop supporting python2"
- Merge "Support uploading image from data and stdin"
- Support uploading image from data and stdin
- Switch stable ansible job to 2.8
- Remove extra python2 test jobs
- Stop supporting python2
- Remove python2 from project-template
- Add dns_publish_fixed_ip attribute to subnets
- Remove duplicate job definition

* Mon Dec 16 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "update OVH vendor entry"
- update OVH vendor entry
- Merge "tox: Keeping going with docs"
- Fix reno index list indent
- Merge "Expose baremetal Node.owner"
- Merge "Update deps for tox venv target"
- Expose baremetal Node.owner
- Update deps for tox venv target
- Fix .. note:: rendering in doc
- tox: Keeping going with docs

* Mon Dec 02 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Keep connection backrefs with weakref.proxy"
- Keep connection backrefs with weakref.proxy
- Merge "Add router add/remove route operations"
- baremetal node: 'error' is a failed state
- Merge "Add clustering update_action"
- Add router add/remove route operations
- Increase test timeout for 2 tests in TestImageProxy class
- Merge "Add support for Node tainted field"
- Merge "Increase dogpile version for Py3.7 compatibility"
- Merge "CI: add ironic-python-agent-builder to the ironic job"
- Merge "Switch to Ussuri jobs"
- Increase dogpile version for Py3.7 compatibility
- CI: add ironic-python-agent-builder to the ironic job
- Merge "Bump the openstackdocstheme extension to 1.20"
- Merge "Add application credential CRUD support"
- Switch to Ussuri jobs
- Add support for Node tainted field
- Add clustering update_action
- Bump the openstackdocstheme extension to 1.20
- Add application credential CRUD support

* Mon Oct 28 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Re-add functional tests on flavor content"
- Re-add functional tests on flavor content
- Merge "fix "How To Contribute" url"
- Merge "Update the constraints url"
- Merge "Start supporting type info"
- Merge "Use generated list of services instead of metaclass"
- Merge "Fix server for later microversion"
- Merge "Use has_service in functional test's require_service"
- Fix server for later microversion
- Start supporting type info
- Use generated list of services instead of metaclass
- Use has_service in functional test's require_service
- Merge "Add a non-voting ironic-inspector job"
- Support vendor data in configdrive building
- Add a non-voting ironic-inspector job
- Merge "Make proxy honor raise_exc in REST primitives"
- Make proxy honor raise_exc in REST primitives
- Make the bifrost job non-voting
- Update the constraints url
- Update master for stable/train
- Merge "baremetal-introspection: add manage_boot argument to start_introspection"
- Merge "Cleanup doc/source/conf.py"
- Merge "Build PDF docs"
- fix "How To Contribute" url
- baremetal-introspection: add manage_boot argument to start_introspection
- Cleanup doc/source/conf.py
- Build PDF docs

* Wed Oct 02 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Oct 02 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches


